/* SqueakController.m created by marcel on Tue 02-Jan-2001 */

#import "SqueakController.h"
#import <Squeak/SqueakInterpreter.h>

@implementation SqueakController

-init
{
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    NSDictionary *appDefaults = [NSDictionary
       dictionaryWithObjectsAndKeys:@"32",@"HeapSize",@"NO",@"UseObjcInterpreter"
          ,nil,nil];
    self=[super init];
    [defaults registerDefaults:appDefaults];
    return self;
}

- (BOOL)applicationShouldOpenUntitledFile:(NSApplication *)sender
{
    return NO;
}

-(BOOL)canOpenAnotherFile
{
    return ![[SqueakInterpreter interpreter] interpreterRunning];
}

-(BOOL)validateMenuItem:(NSMenuItem *)anItem
{
    if ( [anItem action]==@selector(openDocument:) ||  [anItem action]==@selector(openRecentDocument:)) {
        return [self canOpenAnotherFile];
    } else {
        return [super validateUserInterfaceItem:anItem];
    }
}

-(void)setHeapSize:(int)newSize
{
    newSize = MIN( [heapSizeSlider maxValue],MAX( [heapSizeSlider minValue], newSize));
    [heapSizeSlider setIntValue:newSize];
    [heapSizeField setIntValue:newSize];
}

-(void)openPreferences:sender
{
    if ( !heapSizeField ) {
        [NSBundle loadNibNamed:@"Preferences" owner:self];
    }
    [self setHeapSize:[[NSUserDefaults standardUserDefaults] integerForKey:@"HeapSize"]];
    [objcFlag setIntValue:[[NSUserDefaults standardUserDefaults] boolForKey:@"UseObjcInterpreter"]];

    [[heapSizeField window] makeKeyAndOrderFront:self];
}

-(void)setPreferences:sender
{
    [[NSUserDefaults standardUserDefaults] setInteger:[heapSizeSlider intValue] forKey:@"HeapSize"];
    [[NSUserDefaults standardUserDefaults] setBool:[objcFlag intValue] forKey:@"UseObjcInterpreter"];
    [[NSUserDefaults standardUserDefaults] synchronize];
    [[heapSizeField window] performClose:self];
}

@end
