/* interp-objc.h created by marcel on Fri 05-Jan-2001 */



#import <Foundation/Foundation.h>
#include "sq.h"


@interface ObjectMemory : NSObject
{
	int memory;
	int youngStart;
	int endOfMemory;
	int memoryLimit;
	int nilObj;
	int falseObj;
	int trueObj;
	int specialObjectsOop;
	int rootTable[2501];
	int rootTableCount;
	int child;
	int field;
	int parentField;
	int freeBlock;
	int lastHash;
	int allocationCount;
	int lowSpaceThreshold;
	int signalLowSpace;
	int compStart;
	int compEnd;
	int fwdTableNext;
	int fwdTableLast;
	int remapBuffer[26];
	int remapBufferCount;
	int allocationsBetweenGCs;
	int tenuringThreshold;
	int statFullGCs;
	int statFullGCMSecs;
	int statIncrGCs;
	int statIncrGCMSecs;
	int statTenures;
	int statRootTableOverflows;
	int freeContexts;
	int freeLargeContexts;
	int interruptCheckCounter;
	int displayBits;
}

			-(int)nonWeakFieldsOf:(int )oop;
			-(int)ioMSecs;
			-(int)fetchStackPointerOf:(int )aContext;
			-(int)formatOfClass:(int )classPointer;

-(int)lowestFreeAfter:(int )chunk;
-(int)sizeHeader:(int )oop;
-(int)adjustFieldsAndClassOf:(int )oop by:(int )offsetBytes;
-(int)classExternalData;
-(int)isIntegerObject:(int )objectPointer;
-(int)headerType:(int )oop;
-(int)fullCompaction;
-(int)isWords:(int )oop;
-(int)sufficientSpaceAfterGC:(int )minFree;
-(int)setSizeOfFree:(int )chunk to:(int )byteSize;
-(int)extraHeaderBytes:(int )oopOrChunk;
-(int)remapFieldsAndClassOf:(int )oop;
-(int)splObj:(int )index;
-(int)objectAfterWhileForwarding:(int )oop;
-(int)classExternalLibrary;
-(int)upward;
-(int)checkedLongAt:(int )byteAddress;
-(int)startObj;
-(int)fetchClassOfNonInt:(int )oop;
-(int)remapClassOf:(int )oop;
-(int)become:(int )array1 with:(int )array2 twoWay:(int )twoWayFlag;
-(int)allYoung:(int )array1 and:(int )array2;
-(int)initForwardBlock:(int )fwdBlock mapping:(int )oop to:(int )newOop withBackPtr:(int )backFlag;
-(int)falseObject;
-(int)instanceAfter:(int )objectPointer;
-(int)allocateChunk:(int )byteSize;
-(int)instantiateContext:(int )classPointer sizeInBytes:(int )sizeInBytes;
-(int)isBytes:(int )oop;
-(int)checkedByteAt:(int )byteAddress;
-(int)become:(int )array1 with:(int )array2;
-(int)prepareForwardingTableForBecoming:(int )array1 with:(int )array2 twoWay:(int )twoWayFlag;
-(int)sizeOfFree:(int )oop;
-(int)allocate:(int )byteSize headerSize:(int )hdrSize h1:(int )baseHeader h2:(int )classOop h3:(int )extendedSize doFill:(int )doFill with:(int )fillWord;
-(int)classExternalFunction;
-(int)incCompBody;
-(int)instantiateSmallClass:(int )classPointer sizeInBytes:(int )sizeInBytes fill:(int )fillValue;
-(int)fwdBlockValidate:(int )addr;
-(int)sweepPhase;
-(int)classExternalStructure;
-(int)storeWord:(int )fieldIndex ofObject:(int )oop withValue:(int )valueWord;
-(int)fwdBlockGet:(int )blkSize;
-(int)displayObject;
-(int)classLargeNegativeInteger;
-(int)classString;
-(int)pushRemappableOop:(int )oop;
-(int)popRemappableOop;
-(int)classLargePositiveInteger;
-(int)classHeader:(int )oop;
-(int)integerValueOf:(int )objectPointer;
-(int)restoreHeaderOf:(int )oop;
-(int)initializeObjectMemory:(int )bytesToShift;
-(int)validateRoots;
-(int)restoreHeadersAfterForwardBecome;
-(int)initialInstanceOf:(int )classPointer;
-(int)finalizeReference:(int )oop;
-(int)aComment;
-(int)lastPointerOf:(int )oop;
-(int)isPointers:(int )oop;
-(int)isWeak:(int )oop;
-(int)incrementalCompaction;
-(int)clearRootsTable;
-(int)newObjectHash;
-(int)beRootIfOld:(int )oop;
-(int)containOnlyOops:(int )array1 and:(int )array2;
-(int)trueObject;
-(int)classSmallInteger;
-(int)accessibleObjectAfter:(int )oop;
-(int)firstObject;
-(int)firstAccessibleObject;
-(int)chunkFromOop:(int )oop;
-(int)possibleRootStoreInto:(int )oop value:(int )valueObj;
-(int)instantiateClass:(int )classPointer indexableSize:(int )size;
-(int)sizeBitsOfSafe:(int )oop;
-(int)clone:(int )oop;
-(int)classCharacter;
-(int)classSemaphore;
-(int)isWordsOrBytes:(int )oop;
-(int)classExternalAddress;
-(int)aFinalizationComment;
-(int)incrementalGC;
-(int)classFloat;
-(int)fetchPointer:(int )fieldIndex ofObject:(int )oop;
-(int)storePointer:(int )fieldIndex ofObject:(int )oop withValue:(int )valuePointer;
-(int)startOfMemory;
-(int)oopFromChunk:(int )chunk;
-(int)classBitmap;
-(int)characterTable;
-(int)baseHeader:(int )oop;
-(int)initializeMemoryFirstFree:(int )firstFree;
-(int)nilObject;
-(int)storePointerUnchecked:(int )fieldIndex ofObject:(int )oop withValue:(int )valuePointer;
-(int)classPoint;
-(int)incCompMove:(int )bytesFreed;
-(int)restoreHeadersAfterBecoming:(int )list1 with:(int )list2;
-(int)startField;
-(int)sufficientSpaceToAllocate:(int )bytes;
-(int)isFreeObject:(int )oop;
-(int)fwdTableInit:(int )blkSize;
-(int)integerObjectOf:(int )value;
-(int)fetchClassOf:(int )oop;
-(int)remap:(int )oop;
-(int)isIntegerValue:(int )intValue;
-(int)markAndTrace:(int )oop;
-(int)mapPointersInObjectsFrom:(int )memStart to:(int )memEnd;
-(int)classArray;
-(int)fetchByte:(int )byteIndex ofObject:(int )oop;
-(int)fullGC;
-(int)noteAsRoot:(int )oop headerLoc:(int )headerLoc;
-(int)allocateOrRecycleContext:(int )needsLarge;
-(int)isObjectForwarded:(int )oop;
-(int)lastPointerWhileForwarding:(int )oop;
-(int)markPhase;
-(int)recycleContextIfPossible:(int )cntxOop;
-(int)hashBitsOf:(int )oop;
-(int)fetchWord:(int )fieldIndex ofObject:(int )oop;
-(int)incCompMakeFwd;
-(int)storeByte:(int )byteIndex ofObject:(int )oop withValue:(int )valueByte;
-(int)checkAddress:(int )byteAddress;
-(int)isInMemory:(int )address;
-(int)checkedByteAt:(int )byteAddress put:(int )byte;
-(int)checkedLongAt:(int )byteAddress put:(int )a32BitInteger;
-(int)beRootWhileForwarding:(int )oop;
-(int)classByteArray;
-(int)formatOf:(int )oop;
-(int)adjustAllOopsBy:(int )bytesToShift;
-(int)rightType:(int )headerWord;
-(int)sizeBitsOf:(int )oop;
-(int)objectAfter:(int )oop;
-(int)fetchWordLengthOf:(int )objectPointer;
@end


@interface Interpreter : ObjectMemory
{
	int activeContext;
	int theHomeContext;
	int method;
	int receiver;
	int instructionPointer;
	int stackPointer;
	int localIP;
	int localSP;
	int localHomeContext;
	int messageSelector;
	int argumentCount;
	int newMethod;
	int currentBytecode;
	int successFlag;
	int primitiveIndex;
	int methodCache[2049];
	int atCache[65];
	int lkupClass;
	int reclaimableContextCount;
	int nextPollTick;
	int nextWakeupTick;
	int lastTick;
	int interruptKeycode;
	int interruptPending;
	int semaphoresToSignalA[501];
	int semaphoresUseBufferA;
	int semaphoresToSignalCountA;
	int semaphoresToSignalB[501];
	int semaphoresToSignalCountB;
	int savedWindowSize;
	int fullScreenFlag;
	int deferDisplayUpdates;
	int pendingFinalizationSignals;
	int compilerInitialized;
	int (*compilerHooks[11])();
	int extraVMMemory;
	const char *interpreterVersion ;
	char* obsoleteIndexedPrimitiveTable[600][3] ;
	const char* obsoleteNamedPrimitiveTable[600][3] ;
	int interpreterProxy;
	int showSurfaceFn;
	int interruptCheckCounterFeedBackReset;
	int interruptChecksEveryNms;
}
-(int)primitiveFloatMultiply;
-(int)bytecodePrimMakePoint;
-(int)singleExtendedSuperBytecode;
-(int)resume:(int )aProcess;
-(int)synchronousSignal:(int )aSemaphore;
-(int)areIntegers:(int )oop1 and:(int )oop2;
-(int)bytecodePrimDiv;
-(int)nullCompilerHook;
-(int)primitivePerformInSuperclass;
-(int)bytecodePrimGreaterOrEqual;
-(int)checkImageVersionFrom:(sqImageFile )f startingAt:(int )imageOffset;
-(int)popPos32BitInteger;
-(int)findObsoleteNamedPrimitive:(char * )functionName length:(int )functionLength;
-(int)primitiveWait;
-(int)normalSend;
-(int)compare31or32Bits:(int )obj1 equal:(int )obj2;
-(int)primitiveSomeObject;
-(void *)firstFixedField:(int )oop;
-(int)compilerPreSnapshotHook;
-(int)shortConditionalJump;
-(int)primitiveBlockCopy;
-(int)primitiveStringReplace;
-(int)methodPrimitiveIndex;
-(int)lookupMethodInClass:(int )class;
-(int)primitiveGetNextEvent;
-(int)primitivePushNil;
-(double)floatValueOf:(int )oop;
-(int)bytecodePrimMod;
-(int)stackObjectValue:(int )offset;
-(int)mapInterpreterOops;
-(int)primitiveListExternalModule;
-(int)markAndTraceInterpreterOops;
-(int)primitiveStoreStackp;
-(int)pushConstantTrueBytecode;
-(int)booleanValueOf:(int )obj;
-(int)findSelectorOfMethod:(int )meth forReceiver:(int )rcvr;
-(int)superclassOf:(int )classPointer;
-(int)popInteger;
-(int)primitiveSuspend;
-(int)primitiveDiv;
-(int)bytecodePrimPointX;
-(int)primitiveSquareRoot;
-(int)slotSizeOf:(int )oop;
-(int)primitiveFloatAdd:(int )rcvrOop toArg:(int )argOop;
-(int)longJumpIfTrue;
-(int)booleanCheat:(int )cond;
-(double)fetchFloat:(int )fieldIndex ofObject:(int )objectPointer;
-(int)jump:(int )offset;
-(int)bytecodePrimNextPut;
-(int)addLastLink:(int )proc toList:(int )aList;
-(int)pushReceiverBytecode;
-(int)primitiveInputSemaphore;
-(int)commonVariableInternal:(int )rcvr at:(int )index cacheIndex:(int )atIx;
-(int)byteSwapped:(int )w;
-(int)shortUnconditionalJump;
-(int)primitiveBeDisplay;
-(int)removeFirstLinkOfList:(int )aList;
-(int)signalFinalization:(int )weakReferenceOop;
-(int)primitiveKbdNext;
-(int)pop:(int )nItems;
-(int)internalBytecodeActivateNewMethod;
-(int)byteSizeOf:(int )oop;
-(int)flushExternalPrimitiveOf:(int )methodPtr;
-(int)commonVariable:(int )rcvr at:(int )index cacheIndex:(int )atIx;
-(int)primitiveObsoleteIndexedPrimitive;
-(int)primitiveFloatSubtract;
-(int)primitiveSpecialObjectsOop;
-(int)print:(char *)s;
-(int)positive32BitIntegerFor:(int )integerValue;
-(int)bytecodePrimValue;
-(int)primitiveLogN;
-(int)literal:(int )offset;
-(int)primitiveResume;
-(int)primitiveEqual;
-(int)stSizeOf:(int )oop;
-(int)extendedStoreBytecode;
-(int)getLongFromFile:(sqImageFile )f swap:(int )swapFlag;
-(int)internalStackTop;
-(int)bytecodePrimPointY;
-(int)internalizeIPandSP;
-(int)primitiveFloatEqual;
-(int)pushLiteralConstantBytecode;
-(int)doPrimitiveMod:(int )rcvr by:(int )arg;
-(int)pushActiveContextBytecode;
-(int)printStringOf:(int )oop;
-(int)pushConstantFalseBytecode;
-(int)primitiveAtPut;
-(int)primitiveStringAt;
-(void *)arrayValueOf:(int )arrayOop;
-(int)pushReceiverVariable:(int )fieldIndex;
-(int)okStreamArrayClass:(int )cl;
-(int)primitiveSnapshot;
-(int)fixedFieldsOf:(int )oop format:(int )fmt length:(int )wordLength;
-(int)bytecodePrimValueWithArg;
-(int)bytecodePrimBitAnd;
-(int)primitivePushTrue;
-(int)stackValue:(int )offset;
-(int)storeInteger:(int )fieldIndex ofObject:(int )objectPointer withValue:(int )integerValue;
-(int)primitiveClass;
-(int)primIndex;
-(int)compilerPostGC;
-(int)okArrayClass:(int )cl;
-(int)longUnconditionalJump;
-(int)enableCompiler;
-(int)fullDisplayUpdate;
-(int)preGCAction:(int )fullGCFlag;
-(int)primitiveFloatDivide;
-(int)literalCountOfHeader:(int )headerPointer;
-(int)primitivePushMinusOne;
-(int)sender;
-(int)internalPush:(int )object;
-(int)primitiveSine;
-(int)experimentalBytecode;
-(int)primitiveShortAt;
-(int)primitiveMakePoint;
-(int)externalizeIPandSP;
-(int)bytecodePrimAtEnd;
-(int)primitiveFloatEqual:(int )rcvrOop toArg:(int )argOop;
-(int)commonAtPut:(int )stringy;
-(int)compilerPostSnapshot;
-(int)pushFloat:(double )f;
-(int)flushMethodCache;
-(int)readImageFromFile:(sqImageFile )f HeapSize:(int )desiredHeapSize StartingAt:(int )imageOffset;
-(int)makePointwithxValue:(int )xValue yValue:(int )yValue;
-(int)restoreHeadersFrom:(int )firstIn to:(int )lastIn from:(int )hdrBaseIn and:(int )firstOut to:(int )lastOut from:(int )hdrBaseOut;
-(int)forward:(int )oop to:(int )newOop savingOopAt:(int )oopPtr andHeaderAt:(int )hdrPtr;
-(int)flushObsoleteIndexedPrimitives;
-(int)putToSleep:(int )aProcess;
-(double)loadFloatOrIntFrom:(int )floatOrInt;
-(int)primitiveClipboardText;
-(int)primitiveSignalAtBytesLeft;
-(int)signalExternalSemaphores;
-(int)primitiveObjectPointsTo;
-(int)signed32BitIntegerFor:(int )integerValue;
-(int)okayFields:(int )oop;
-(int)primitiveArctan;
-(int)pushConstantNilBytecode;
-(int)primitiveRelinquishProcessor;
-(int)primitivePushTwo;
-(int)cr;
-(int)sizeOfSTArrayFromCPrimitive:(void *)cPtr;
-(int)stackIntegerValue:(int )offset;
-(int)doPrimitiveDiv:(int )rcvr by:(int )arg;
-(int)loadBitBltFrom:(int )bb;
-(int)primitivePushSelf;
-(int)returnTopFromMethod;
-(int)methodArgumentCount;
-(int)activateNewMethod;
-(int)stObject:(int )array at:(int )index;
-(int)pushInteger:(int )integerValue;
-(int)returnFalse;
-(int)primitiveMethod;
-(int)isContext:(int )oop header:(int )hdr;
-(int)bytecodePrimNext;
-(int)allAccessibleObjectsOkay;
-(int)internalPop:(int )nItems thenPush:(int )oop;
-(int)asciiOfCharacter:(int )characterObj;
-(int)specialSelector:(int )index;
-(int)success:(int )successValue;
-(int)primitiveLessOrEqual;
-(int)rewriteMethodCacheSel:(int )selector class:(int )class primIndex:(int )localPrimIndex;
-(int)imageSegmentVersion;
-(int)primitiveImageName;
-(int)primitivePerform;
-(int)primitiveInstVarsPutFromStack;
-(void *)firstIndexableField:(int )oop;
-(int)primitiveFormPrint;
-(int)signExtend16:(int )int16;
-(int)argumentCountOf:(int )methodPointer;
-(int)pushConstantTwoBytecode;
-(int)commonVariable:(int )rcvr at:(int )index put:(int )value cacheIndex:(int )atIx;
-(int)includesBehavior:(int )aClass ThatOf:(int )aSuperclass;
-(int)primitiveNextInstance;
-(int)findNewMethodInClass:(int )class;
-(int)copyBits;
-(int)primitiveBitShift;
-(int)primitiveFloatDivide:(int )rcvrOop byArg:(int )argOop;
-(int)primitiveNoop;
-(int)primitiveTruncated;
-(int)checkedIntegerValueOf:(int )intOop;
-(int)primitivePerformAt:(int )lookupClass;
-(int)primitiveBeCursor;
-(int)primitiveMod;
-(int)primitiveFloatLessThan;
-(int)primitiveMultiply;
-(int)primitiveFloatNotEqual;
-(int)primitiveConstantFill;
-(int)primitiveGetTabletParameters;
-(int)primitiveObjectAtPut;
-(int)compilerProcessChangeHook;
-(int)assertClassOf:(int )oop is:(int )classOop;
-(int)reverseBytesInImage;
-(int)primitiveBitXor;
-(int)fetchContextRegisters:(int )activeCntx;
-(int)primitiveBytesLeft;
-(int)primitiveAsFloat;
-(int)internalPop:(int )nItems;
-(int)nonWeakFieldsOf:(int )oop;
-(int)primitiveIndexOf:(int )methodPointer;
-(int)bytecodePrimAdd;
-(int)primitiveNext;
-(int)primitiveGetAttribute;
-(int)fetchStackPointerOf:(int )aContext;
-(int)unPop:(int )nItems;
-(int)formatOfClass:(int )classPointer;
-(int)internalExecuteNewMethod;
-(int)singleExtendedSendBytecode;
-(int)storeContextRegisters:(int )activeCntx;
-(int)pushBool:(int )trueOrFalse;
-(int)isContextHeader:(int )aHeader;
-(int)createActualMessageTo:(int )aClass;
-(int)readableFormat:(int )imageVersion;
-(int)argumentCountOfBlock:(int )blockPointer;
-(int)returnReceiver;
-(int)primitiveTimesTwoPower;
-(int)primitiveResponse;
-(int)pushLiteralVariableBytecode;
-(int)extendedPushBytecode;
-(int)internalNewActiveContext:(int )aContext;
-(int)primitiveSignalAtMilliseconds;
-(int)primitiveGreaterThan;
-(double)popFloat;
-(int)displayBitsOf:(int )aForm Left:(int )l Top:(int )t Right:(int )r Bottom:(int )b;
-(int)writeImageFile:(int )imageBytes;
-(int)reverseDisplayFrom:(int )startIndex to:(int )endIndex;
-(int)addToMethodCacheSel:(int )selector class:(int )class method:(int )meth primIndex:(int )localPrimIndex;
-(int)compilerFlushCache:(int )aCompiledMethod;
-(int)printNum:(int )n;
-(int)primitiveAt;
-(int)transferTo:(int )aProc;
-(int)bytecodePrimMultiply;
-(int)bytecodePrimEqual;
-(int)primitiveFloatGreater:(int )rcvrOop thanArg:(int )argOop;
-(int)push:(int )object;
-(int)primitivePerformWithArgs;
-(int)pushLiteralConstant:(int )literalIndex;
-(int)primitiveBitAnd;
-(int)primitiveAdd;
-(int)storeAndPopReceiverVariableBytecode;
-(int)primitiveCalloutToFFI;
-(int)bytecodePrimAtPut;
-(int)longJumpIfFalse;
-(int)caller;
-(int)bytecodePrimClass;
-(int)primitiveValueWithArgs;
-(int)primitiveIncrementalGC;
-(int)primitiveUnloadModule;
-(int)lookupInMethodCacheSel:(int )selector class:(int )class;
-(int)classNameOf:(int )aClass Is:(char *)className;
-(int)quickFetchInteger:(int )fieldIndex ofObject:(int )objectPointer;
-(int)primitiveSignal;
-(int)storeAndPopTemporaryVariableBytecode;
-(int)primitiveTestDisplayDepth;
-(int)install:(int )rcvr inAtCache:(int *)cache at:(int )atIx string:(int )stringy;
-(int)primitiveInterruptSemaphore;
-(int)primitiveSubtract;
-(int)signed32BitValueOf:(int )oop;
-(int)printChar:(int )aByte;
-(int)primitiveFloatGreaterOrEqual;
-(int)popStack;
-(int)byteSwapByteObjectsFrom:(int )startOop to:(int )stopAddr;
-(int)internalQuickCheckForInterrupts;
-(int)moduleUnloaded:(char * )aModuleName;
-(int)is:(int )oop MemberOf:(char *)className;
-(int)primitiveScreenSize;
-(int)failed;
-(int)popStackBytecode;
-(int)pop2AndPushIntegerIfOK:(int )integerResult;
-(int)initCompilerHooks;
-(int)bytecodePrimEquivalent;
-(int)extendedStoreAndPopBytecode;
-(int)okayInterpreterObjects;
-(int)returnValue:(int )resultObj to:(int )returnContext;
-(int)primitiveListBuiltinModule;
-(int)bytecodePrimNewWithArg;
-(int)primitiveExponent;
-(int)primitiveQuo;
-(int)primitiveFloatMultiply:(int )rcvrOop byArg:(int )argOop;
-(int)primitiveExp;
-(int)primitiveFlushCacheSelective;
-(int)storeInstructionPointerValue:(int )value inContext:(int )contextPointer;
-(int)primitiveFloatSubtract:(int )rcvrOop fromArg:(int )argOop;
-(int)primitiveBeep;
-(int)primitiveBitOr;
-(int)is:(int )oop KindOf:(char *)className;
-(int)primitiveArrayBecomeOneWay;
-(int)bytecodePrimSubtract;
-(int)oopHasOkayClass:(int )oop;
-(int)primitiveLoadImageSegment;
-(int)bytecodePrimDivide;
-(int)stObject:(int )array at:(int )index put:(int )value;
-(int)secondExtendedSendBytecode;
-(int)internalPrimitiveValue;
-(int)postGCAction;
-(int)superclassSend;
-(int)wakeHighestPriority;
-(int)primitiveVMPath;
-(int)bytecodePrimAt;
-(int)pushConstantMinusOneBytecode;
-(int)primitiveFloatLess:(int )rcvrOop thanArg:(int )argOop;
-(int)primitiveSetInterruptKey;
-(int)primitiveSecondsClock;
-(int)unknownBytecode;
-(int)primitivePointX;
-(int)sendLiteralSelectorBytecode;
-(int)primitiveInputWord;
-(int)compilerPostSnapshotHook;
-(double)stackFloatValue:(int )offset;
-(int)primitiveLoadInstVar;
-(int)checkBooleanResult:(int )result;
-(int)primitiveFailAfterCleanup:(int )outPointerArray;
-(int)primitiveShortAtPut;
-(int)compilerPreSnapshot;
-(int)primitiveScanCharacters;
-(int)lookupMethodInDictionary:(int )dictionary;
-(int)fetchInteger:(int )fieldIndex ofObject:(int )objectPointer;
-(int)primitiveFlushCacheByMethod;
-(int)verifyCleanHeaders;
-(int)okayOop:(int )oop;
-(int)bytecodePrimLessOrEqual;
-(int)primitiveInstVarAt;
-(int)primitiveLowSpaceSemaphore;
-(int)primitiveExternalCall;
-(int)primitiveNextPut;
-(int)primitiveNextObject;
-(int)checkForInterrupts;
-(int)internalStackValue:(int )offset;
-(int)argCount;
-(int)internalStoreContextRegisters:(int )activeCntx;
-(int)isMethodContextHeader:(int )aHeader;
-(int)compilerPreGCHook:(int )fullGCFlag;
-(int)bytecodeExecuteNewMethod;
-(int)internalFindNewMethod;
-(int)signalSemaphoreWithIndex:(int )index;
-(int)bytecodePrimBitShift;
-(int)primitiveShowDisplayRect;
-(int)reverseBytesFrom:(int )startAddr to:(int )stopAddr;
-(int)getCurrentBytecode;
-(int)printNameOfClass:(int )classOop count:(int )cnt;
-(int)jumplfTrueBy:(int )offset;
-(int)fetchNextBytecode;
-(int)flushExternalPrimitives;
-(int)primitiveInstVarAtPut;
-(int)primitivePointY;
-(int)primitiveFlushExternalPrimitives;
-(int)primitiveObjectAt;
-(int)bytecodePrimSize;
-(int)primitiveArrayBecome;
-(int)bytecodeActivateNewMethod;
-(int)jumplfFalseBy:(int )offset;
-(int)compilerFlushCacheHook:(int )aCompiledMethod;
-(int)isIndexable:(int )oop;
-(int)bytecodePrimDo;
-(int)primitiveStringAtPut;
-(int)primitiveAsOop;
-(int)primitivePushZero;
-(int)byteLengthOf:(int )oop;
-(int)transfer:(int )count fromIndex:(int )firstFrom ofObject:(int )fromOop toIndex:(int )firstTo ofObject:(int )toOop;
-(int)primitivePushFalse;
-(int)primitiveFloatLessOrEqual;
-(int)primitiveLessThan;
-(int)primitivePushOne;
-(int)primitiveNotEqual;
-(int)primitiveSetFullScreen;
-(int)doubleExtendedDoAnythingBytecode;
-(int)duplicateTopBytecode;
-(int)primitiveFractionalPart;
-(int)loadInitialContext;
-(int)compilerMapFrom:(int )memStart to:(int )memEnd;
-(int)isEmptyList:(int )aLinkedList;
-(int)transfer:(int )count from:(int )src to:(int )dst;
-(int)characterForAscii:(int )ascii;
-(int)returnTrue;
-(int)initializeInterpreter:(int )bytesToShift;
-(int)cleanUpContexts;
-(int)bytecodePrimGreaterThan;
-(int)bytecodePrimBlockCopy;
-(int)primitiveSomeInstance;
-(int)primitiveDeferDisplayUpdates;
-(int)primitiveMouseButtons;
-(int)byteSwapByteObjects;
-(int)headerOf:(int )methodPointer;
-(int)compilerActivateMethod;
-(int)compilerMark;
-(int)primitiveStoreImageSegment;
-(int)primitiveQuit;
-(int)primitiveExitToDebugger;
-(int)okayActiveProcessStack;
-(int)executeNewMethod;
-(int)primitiveMillisecondClock;
-(int)commonAt:(int )stringy;
-(int)newActiveContext:(int )aContext;
-(int)primitiveValue;
-(int)literal:(int )offset ofMethod:(int )methodPointer;
-(int)primitiveFail;
-(int)primitiveSize;
-(int)primitiveMousePoint;
-(int)primitiveFullGC;
-(void *)fetchArray:(int )fieldIndex ofObject:(int )objectPointer;
-(int)primitiveVMParameter;
-(int)fetchIntegerOrTruncFloat:(int )fieldIndex ofObject:(int )objectPointer;
-(int)bytecodePrimNew;
-(int)positive32BitValueOf:(int )oop;
-(int)bytecodePrimLessThan;
-(int)bytecodePrimNotEqual;
-(int)compilerMapHookFrom:(int )memStart to:(int )memEnd;
-(int)imageFormatVersion;
-(int)checkIntegerResult:(int )integerResult;
-(int)primitiveEquivalent;
-(int)quickCheckForInterrupts;
-(int)subscript:(int )array with:(int )index format:(int )fmt;
-(int)primitiveNewWithArg;
-(int)pushLiteralVariable:(int )literalIndex;
-(int)primitiveClone;
-(int)primitiveFloatGreaterThan;
-(int)compilerPostGCHook;
-(int)pushConstantZeroBytecode;
-(int)showDisplayBits:(int )aForm Left:(int )l Top:(int )t Right:(int )r Bottom:(int )b;
-(int)findClassOfMethod:(int )meth forReceiver:(int )rcvr;
-(int)compilerActivateMethodHook;
-(int)storeStackPointerValue:(int )value inContext:(int )contextPointer;
-(int)compilerProcessChange;
-(int)compilerPreGC:(int )fullGCFlag;
-(int)disableCompiler;
-(int)putLong:(int )n toFile:(sqImageFile )f;
-(int)schedulerPointer;
-(int)lengthOf:(int )oop baseHeader:(int )hdr format:(int )fmt;
-(int)pushTemporaryVariable:(int )temporaryIndex;
-(int)primitiveKbdPeek;
-(int)primitiveDivide;
-(int)primitiveFloatAdd;
-(int)primitiveAtEnd;
-(int)bytecodePrimBitOr;
-(int)internalActivateNewMethod;
-(int)setCompilerInitialized:(int )newFlag;
-(int)subscript:(int )array with:(int )index storing:(int )oopToStore format:(int )fmt;
-(int)internalFetchContextRegisters:(int )activeCntx;
-(int)primitiveNew;
-(int)copyBitsFrom:(int )x0 to:(int )x1 at:(int )y;
-(int)primitiveDoPrimitiveWithArgs;
-(int)isFloatObject:(int )oop;
-(int)floatObjectOf:(double )aFloat;
-(int)pushTemporaryVariableBytecode;
-(int)interpret;
-(int)returnTopFromBlock;
-(int)pop:(int )nItems thenPush:(int )oop;
-(int)pushConstantOneBytecode;
-(int)oopHasOKclass:(int )oop;
-(int)primitiveForceDisplayUpdate;
-(int)methodClassOf:(int )methodPointer;
-(int)temporary:(int )offset;
-(int)sufficientSpaceToInstantiate:(int )classOop indexableSize:(int )size;
-(int)lengthOf:(int )oop;
-(int)stackPointerIndex;
-(int)primitiveSetDisplayMode;
-(int)stackTop;
-(int)fetchByte;
-(int)primitiveFlushCache;
-(int)compilerMarkHook;
-(int)printCallStack;
-(int)copyObj:(int )oop toSegment:(int )segmentWordArray addr:(int )lastSeg stopAt:(int )stopAddr saveOopAt:(int )oopPtr headerAt:(int )hdrPtr;
-(int)literalCountOf:(int )methodPointer;
-(int)pushReceiverVariableBytecode;
-(int)primitiveNewMethod;
-(int)returnNil;
-(int)primitiveGreaterOrEqual;
@end
