/* SqueakInterpreterTimes.m created by marcel on Wed 20-Dec-2000 */

#import "SqueakInterpreterTimes.h"
#include <sys/time.h>

@implementation SqueakInterpreter(Times)

-(NSTimeInterval)_currentTimeInterval
{
    struct timeval tv;
    struct timezone tz;
    gettimeofday( &tv, &tz );
    return (NSTimeInterval)tv.tv_sec + (NSTimeInterval)tv.tv_usec * (1.0/1000000.0);
}

-(int)ioMSecs
{
    double secs;
    secs = [self _currentTimeInterval] - startupTimeInterval;
    return (int)(secs * 1000);
}

-(int)ioMicroMSecs
{
    return([self ioMSecs]);
}

-(int)ioLowResMSecs
{
    double secs;
    secs = lowResMSTime - startupTimeInterval;
    return (int)(secs * 1000);
}

-(NSTimeInterval)referenceDate1901
{
    static NSTimeInterval referenceDate1901=0;
    if ( referenceDate1901 == 0 ) {
        referenceDate1901 =  [[[NSCalendarDate alloc] initWithYear:1901
                                                            month:1 day:1 hour:0 minute:0 second:0
                                                         timeZone:[NSTimeZone timeZoneWithName:@"GMT"]] timeIntervalSinceReferenceDate];

    }
    return referenceDate1901;
}

-(unsigned int)ioSeconds
{
    NSTimeInterval ref1901 = [self referenceDate1901];
    NSTimeInterval now = [NSDate timeIntervalSinceReferenceDate];
    return (unsigned int)( now - ref1901 );
}

@end

int ioMicroMSecs(void)
{
    return [[SqueakInterpreter interpreter] ioMicroMSecs];
}

int ioLowResMSecs(void)
{
    return( [[SqueakInterpreter interpreter] ioLowResMSecs]);
//    return( [[SqueakInterpreter interpreter] ioMicroMSecs]);
}

int ioMSecs(void)
{
    return([[SqueakInterpreter interpreter] ioMSecs]);
}

int ioSeconds(void)
{
    id pool=[[NSAutoreleasePool alloc] init];
    int seconds = [[SqueakInterpreter interpreter] ioSeconds];
    [pool release];
    return seconds;
}



