/* SqueakObjcInterpreter.m created by marcel on Fri 05-Jan-2001 */

#import "SqueakObjcInterpreter.h"
#import "SqueakImageFile.h"
#import "interp-objc.h"

@implementation SqueakObjcInterpreter

static id sharedInterpreter=nil;

+interpreter
{
    if ( !sharedInterpreter ) {
        sharedInterpreter=[[self alloc] init];
    }
    return sharedInterpreter;
}


-init
{
    self = [super init];
    interpreter = [[Interpreter alloc] init];
    return self;
}

-(void)startInterpreter
{
    id pool=[[NSAutoreleasePool alloc] init];
    startupTimeInterval = [NSDate timeIntervalSinceReferenceDate];
    [pool release];
    interpreterRunning=YES;
    [interpreter interpret];
    interpreterRunning=NO;
}



-(BOOL)readImageFile:(NSString*)newImagePath withHeapSize:(int)heapSize
{
    id pool=[[NSAutoreleasePool alloc] init];
    id imageFile=[SqueakImageFile imageFileWithName:newImagePath mode:@"r"];
    if ( imageFile ) {
        [self setImagePath:newImagePath];
        [interpreter readImageFromFile:imageFile HeapSize:heapSize StartingAt:0];
        [imageFile close];
    }
    [pool release];
    return imageFile != nil;
}


@end
