/* SqViewBitmapConversion.m created by marcel on Fri 04-Dec-1998 */

#import "SqViewBitmapConversion.h"

@implementation SqView(BitmapConversion)

#define debug(a)

#define CHECKANDRETURN(expr) \
	{ NSBitmapImageRep* bitmap=expr; if(bitmap!=0){return(bitmap);}\
        NSLog(@"initData:%08x\npixelsWide:%d\npixelsHigh:%d\nbitsPerSample:%d\nsamplesPerPixel:%d\nhasAlpha:%d\nisPlanar:%d\ncolorSpaceName:%@\nbytesPerRow:%d\nbitsPerPixel:%d\n",\
				(int)dBits,right-left,bottom-top,bitsPerSample,\
				samplesPerPixel,NO,NO,colorSpace,bytesPerRow,bitsPerPixel);\
		return(0);\
	}
	
	-(NSBitmapImageRep*)extractPixels_1_to_2:(void*)srcBits
			srcPixelWidth:(int)srcPixelWidth
			left:(int)left right:(int)right 
			top:(int)top bottom:(int)bottom
			position:(NSPoint*)position
	{
		debug(int dummy=fprintf(stderr,"%s\n",sel_getName(_cmd));\
			int fummy=fflush(stderr);)
		static unsigned char One_to_Two[16]={
			0x00,0x03,0x0c,0x0f,
			0x30,0x33,0x3c,0x3f,
			0xc0,0xc3,0xcc,0xcf,
			0xf0,0xf3,0xfc,0xff
		};
		unsigned char*      sBits=srcBits;
		unsigned char*      dBits;
		int                 bitsPerSample;
		int                 samplesPerPixel;
		int                 bytesPerRow;
		int                 bitsPerPixel;
		NSString*        colorSpace;

		int                 neededBytes;
		int                 sRowSlots;
		int                 minY;
		int                 maxY;
		int                 minX;
		int                 maxX;
		int                 i;
		int                 srcY;
		
		if((srcPixelWidth%8)!=0){
			fprintf(stderr,"It would be better to have srcPixelWidth%%8==0 "
					"instead of %d.\n",srcPixelWidth);
			return(0);
		}
		
		sRowSlots=srcPixelWidth/8;
		left=left&(~7);
		right=(right+7)&(~7);
		[self getPoint:position fromSq:left :bottom];
		
		bitsPerSample=2;
		samplesPerPixel=1;
		bytesPerRow=(right-left)/4;
		bitsPerPixel=2;
		colorSpace=NSCalibratedBlackColorSpace;

		neededBytes=bytesPerRow*(bottom-top);
		dBits=(unsigned char*)malloc(neededBytes);
		
		minY=top*sRowSlots;
		maxY=bottom*sRowSlots;
		minX=left/8;
		maxX=right/8;
		
		i=0;
		for(srcY=minY;srcY<maxY;srcY+=sRowSlots){
			int maxXY=srcY+maxX;
			int srcX;
			for(srcX=srcY+minX;srcX<maxXY;srcX++){
				unsigned char src=sBits[srcX];	// NeXT bitmaps are big-endian
				dBits[i++]=One_to_Two[src>>4];
				dBits[i++]=One_to_Two[src&0xf];
			}
		}
		
		CHECKANDRETURN([[NSBitmapImageRep alloc] initWithBitmapDataPlanes:(unsigned char **)&dBits 
				pixelsWide:right-left
				pixelsHigh:bottom-top
				bitsPerSample:bitsPerSample
				samplesPerPixel:samplesPerPixel
				hasAlpha:NO
				isPlanar:NO
				colorSpaceName:colorSpace
				bytesPerRow:bytesPerRow
				bitsPerPixel:bitsPerPixel]);
	}//extractPixels_1_to_2:...;
	


	-(NSBitmapImageRep*)extractPixels_2_to_2:(void*)srcBits
			srcPixelWidth:(int)srcPixelWidth
			left:(int)left right:(int)right 
			top:(int)top bottom:(int)bottom
			position:(NSPoint*)position
	{
		debug(int dummy=fprintf(stderr,"%s\n",sel_getName(_cmd));\
			int fummy=fflush(stderr);)
		unsigned char*      sBits=srcBits;
		unsigned char*      dBits;
		int                 bitsPerSample;
		int                 samplesPerPixel;
		int                 bytesPerRow;
		int                 bitsPerPixel;
		NSString*        colorSpace;

		unsigned char*      map=Two_to_Two;
		
		int                 neededBytes;
		int                 sRowSlots;
		int                 minY;
		int                 maxY;
		int                 minX;
		int                 maxX;
		int                 i;
		int                 srcY;
		
		if((srcPixelWidth%4)!=0){
			fprintf(stderr,"It would be better to have srcPixelWidth%%4==0 "
					"instead of %d.\n",srcPixelWidth);
			return(0);
		}
		
		sRowSlots=srcPixelWidth/4;
		left=left&(~3);
		right=(right+3)&(~3);
		[self getPoint:position fromSq:left :bottom];
		
		bitsPerSample=2;
		samplesPerPixel=1;
		bytesPerRow=(right-left)/4;
		bitsPerPixel=2;
		colorSpace=NSCalibratedWhiteColorSpace;

		neededBytes=bytesPerRow*(bottom-top);
		dBits=(unsigned char*)malloc(neededBytes);
		
		minY=top*sRowSlots;
		maxY=bottom*sRowSlots;
		minX=left/4;
		maxX=right/4;
		
		i=0;
		for(srcY=minY;srcY<maxY;srcY+=sRowSlots){
			int maxXY=srcY+maxX;
			int srcX;
			for(srcX=srcY+minX;srcX<maxXY;srcX++){
                dBits[i++]=map[sBits[srcX]];	// NeXT bitmaps are big-endian
			}
		}
		
		CHECKANDRETURN([[NSBitmapImageRep alloc] initWithBitmapDataPlanes:(unsigned char **)&dBits 
				pixelsWide:right-left
				pixelsHigh:bottom-top
				bitsPerSample:bitsPerSample
				samplesPerPixel:samplesPerPixel
				hasAlpha:NO
				isPlanar:NO
				colorSpaceName:colorSpace
				bytesPerRow:bytesPerRow
				bitsPerPixel:bitsPerPixel]);
	}//extractPixels_2_to_2;
	


	-(NSBitmapImageRep*)extractPixels_8_to_2:(void*)srcBits 
			srcPixelWidth:(int)srcPixelWidth
			left:(int)left right:(int)right 
			top:(int)top bottom:(int)bottom
			position:(NSPoint*)position
	{
		debug(int dummy=fprintf(stderr,"%s\n",sel_getName(_cmd));\
			int fummy=fflush(stderr);)
		unsigned char*      sBits=srcBits;
		unsigned char*      dBits;
		int                 bitsPerSample;
		int                 samplesPerPixel;
		int                 bytesPerRow;
		int                 bitsPerPixel;
		NSString*        colorSpace;

		unsigned char*      map=colorMap2Gray;
		
		int                 neededBytes;
		int                 sRowSlots;
		int                 minY;
		int                 maxY;
		int                 minX;
		int                 maxX;
		int                 i;
		int                 srcY;
		
		sRowSlots=srcPixelWidth;
		left=left&(~3);
		right=(right+3)&(~3);
		[self getPoint:position fromSq:left :bottom];
		
		bitsPerSample=2;
		samplesPerPixel=1;
		bytesPerRow=(right-left)/4;
		bitsPerPixel=2;
		colorSpace=NSCalibratedWhiteColorSpace;

		neededBytes=bytesPerRow*(bottom-top);
		dBits=(unsigned char*)malloc(neededBytes);
		
		minY=top*sRowSlots;
		maxY=bottom*sRowSlots;
		minX=left;
		maxX=right;
		
		i=0;
		for(srcY=minY;srcY<maxY;srcY+=sRowSlots){
			int maxXY=srcY+maxX;
			int srcX;
			for(srcX=srcY+minX;srcX<maxXY;srcX+=4){
                dBits[i++]=(map[sBits[srcX]]<<6)  	// NeXT bitmaps are big-endian
						|(map[sBits[srcX+1]]<<4)
						|(map[sBits[srcX+2]]<<2)
						|(map[sBits[srcX+3]]);
			}
		}
		
		CHECKANDRETURN([[NSBitmapImageRep alloc] initWithBitmapDataPlanes:(unsigned char **)&dBits 
				pixelsWide:right-left
				pixelsHigh:bottom-top
				bitsPerSample:bitsPerSample
				samplesPerPixel:samplesPerPixel
				hasAlpha:NO
				isPlanar:NO
				colorSpaceName:colorSpace
				bytesPerRow:bytesPerRow
				bitsPerPixel:bitsPerPixel]);
	}//extractPixels_8_to_2;
	


	-(NSBitmapImageRep*)extractPixels_8_to_8:(void*)srcBits 
			srcPixelWidth:(int)srcPixelWidth
			left:(int)left right:(int)right 
			top:(int)top bottom:(int)bottom
			position:(NSPoint*)position
	{
		debug(int dummy=fprintf(stderr,"%s\n",sel_getName(_cmd));\
			int fummy=fflush(stderr);)
		unsigned char*      sBits=srcBits;
		unsigned char*      dBits;
		int                 bitsPerSample;
		int                 samplesPerPixel;
		int                 bytesPerRow;
		int                 bitsPerPixel;
		NSString*        colorSpace;

		unsigned char*      map=colorMap8Gray;
		
		int                 neededBytes;
		int                 sRowSlots;
		int                 minY;
		int                 maxY;
		int                 minX;
		int                 maxX;
		int                 srcY;
		int                 i;
		
		sRowSlots=srcPixelWidth;
		[self getPoint:position fromSq:left :bottom];
		
		bitsPerSample=8;
		samplesPerPixel=1;
		bytesPerRow=right-left;
		bitsPerPixel=8;
		colorSpace=NSCalibratedWhiteColorSpace;

		neededBytes=bytesPerRow*(bottom-top);
		dBits=(unsigned char*)malloc(neededBytes);
		
		minY=top*sRowSlots;
		maxY=bottom*sRowSlots;
		minX=left;
		maxX=right;
		
		i=0;
		for(srcY=minY;srcY<maxY;srcY+=sRowSlots){
			int maxXY=srcY+maxX;
			int srcX;
			for(srcX=srcY+minX;srcX<maxXY;srcX++){
                dBits[i++]=map[sBits[srcX]];	// NeXT bitmaps are big-endian
			}
		}
		
		CHECKANDRETURN([[NSBitmapImageRep alloc] initWithBitmapDataPlanes:(unsigned char **)&dBits 
				pixelsWide:right-left
				pixelsHigh:bottom-top
				bitsPerSample:bitsPerSample
				samplesPerPixel:samplesPerPixel
				hasAlpha:NO
				isPlanar:NO
				colorSpaceName:colorSpace
				bytesPerRow:bytesPerRow
				bitsPerPixel:bitsPerPixel]);
	}//extractPixels_8_to_8;
	


-(NSBitmapImageRep*)extractPixels_8_to_16:(void*)srcBits
                                     srcPixelWidth:(int)srcPixelWidth
                                              left:(int)left right:(int)right
                                               top:(int)top bottom:(int)bottom
                                          position:(NSPoint*)position
{
    debug(int dummy=fprintf(stderr,"%s\n",sel_getName(_cmd));\
          int fummy=fflush(stderr);)
    unsigned char*      sBits=srcBits;
    unsigned short*     dBits;
    int                 bitsPerSample;
    int                 samplesPerPixel;
    int                 bytesPerRow;
    int                 bitsPerPixel;
    NSString*        colorSpace;

    unsigned short*     map=colorMap16;

    int                 neededBytes;
    int                 sRowSlots;
    int                 minY;
    int                 maxY;
    int                 minX;
    int                 maxX;
    int                 srcY;
    int                 i;

    sRowSlots=srcPixelWidth;
    [self getPoint:position fromSq:left :bottom];

    bitsPerSample=4;
    samplesPerPixel=3;
    bytesPerRow=(right-left)*2;
    bitsPerPixel=16;
    colorSpace=NSDeviceRGBColorSpace;

    neededBytes=bytesPerRow*(bottom-top);
    dBits=(unsigned short*)malloc(neededBytes);

    minY=top*sRowSlots;
    maxY=bottom*sRowSlots;
    minX=left;
    maxX=right;

    i=0;
    for(srcY=minY;srcY<maxY;srcY+=sRowSlots){
        int maxXY=srcY+maxX;
        int srcX;
        for(srcX=srcY+minX;srcX<maxXY;srcX++){
#ifdef __BIG_ENDIAN__
                                dBits[i++]=map[sBits[srcX]];
#else
                                //	0	->	3		4	->	7
                                //	1	->	2		5	->	6
                                //	2	->	1		6	->	5
                                //	3	->	0		7	->	4
                                dBits[i++]=map[sBits[srcX^3]];
#endif
            }
        }

    CHECKANDRETURN([[NSBitmapImageRep alloc]
                      initWithBitmapDataPlanes:(unsigned char **)&dBits
                                    pixelsWide:right-left
                                    pixelsHigh:bottom-top
                                 bitsPerSample:bitsPerSample
                               samplesPerPixel:samplesPerPixel
                                      hasAlpha:NO
                                      isPlanar:NO
                                colorSpaceName:colorSpace
                                   bytesPerRow:bytesPerRow
                                  bitsPerPixel:bitsPerPixel]);
}  


	-(NSBitmapImageRep*)extractPixels_8_to_32:(void*)srcBits 
			srcPixelWidth:(int)srcPixelWidth
			left:(int)left right:(int)right 
			top:(int)top bottom:(int)bottom
			position:(NSPoint*)position
	{
		debug(int dummy=fprintf(stderr,"%s\n",sel_getName(_cmd));\
			int fummy=fflush(stderr);)
		unsigned char*      sBits=srcBits;
		unsigned long*      dBits;
		int                 bitsPerSample;
		int                 samplesPerPixel;
		int                 bytesPerRow;
		int                 bitsPerPixel;
		NSString*        colorSpace;

		unsigned long*      map=colorMap32;
		
		int                 neededBytes;
		int                 sRowSlots;
		int                 minY;
		int                 maxY;
		int                 minX;
		int                 maxX;
		int                 srcY;
		int                 i;
		
		sRowSlots=srcPixelWidth;
		[self getPoint:position fromSq:left :bottom];
		
		bitsPerSample=8;
		samplesPerPixel=3;
		bytesPerRow=(right-left)*4;
		bitsPerPixel=32;
		colorSpace=NSDeviceRGBColorSpace;

		neededBytes=bytesPerRow*(bottom-top);
		dBits=(unsigned long*)malloc(neededBytes);
		
		minY=top*sRowSlots;
		maxY=bottom*sRowSlots;
		minX=left;
		maxX=right;
		
		i=0;
		for(srcY=minY;srcY<maxY;srcY+=sRowSlots){
			int maxXY=srcY+maxX;
			int srcX;
			for(srcX=srcY+minX;srcX<maxXY;srcX++){
#ifdef __BIG_ENDIAN__
				dBits[i++]=map[sBits[srcX]];
#else
				//	0	->	3		4	->	7
				//	1	->	2		5	->	6
				//	2	->	1		6	->	5
				//	3	->	0		7	->	4
				dBits[i++]=map[sBits[srcX^3]];
#endif
			}
		}
		
		CHECKANDRETURN([[NSBitmapImageRep alloc] initWithBitmapDataPlanes:(unsigned char **)&dBits 
				pixelsWide:right-left
				pixelsHigh:bottom-top
				bitsPerSample:bitsPerSample
				samplesPerPixel:samplesPerPixel
				hasAlpha:NO
				isPlanar:NO
				colorSpaceName:colorSpace
				bytesPerRow:bytesPerRow
				bitsPerPixel:bitsPerPixel]);
	}//extractPixels_8_to_32;
	



	-(NSBitmapImageRep*)extractPixels_16_to_16:(void*)srcBits 
			srcPixelWidth:(int)srcPixelWidth
			left:(int)left right:(int)right 
			top:(int)top bottom:(int)bottom
			position:(NSPoint*)position
	{
		debug(int dummy=fprintf(stderr,"%s\n",sel_getName(_cmd));\
			int fummy=fflush(stderr);)
		unsigned short*     sBits=srcBits;
		unsigned short*     dBits;
		int                 bitsPerSample;
		int                 samplesPerPixel;
		int                 bytesPerRow;
		int                 bitsPerPixel;
		NSString*        colorSpace;
		
		int                 neededBytes;
		int                 sRowSlots;
		int                 minY;
		int                 maxY;
		int                 minX;
		int                 maxX;
		int                 srcY;
		int                 i;
		
		sRowSlots=srcPixelWidth;
		[self getPoint:position fromSq:left :bottom];
		
		bitsPerSample=4;
		samplesPerPixel=3;
		bytesPerRow=(right-left)*2;
		bitsPerPixel=16;
		colorSpace=NSDeviceRGBColorSpace;

		neededBytes=bytesPerRow*(bottom-top);
		dBits=(unsigned short*)malloc(neededBytes);
		
		minY=top*sRowSlots;
		maxY=bottom*sRowSlots;
		minX=left;
		maxX=right;
		
		i=0;
		for(srcY=minY;srcY<maxY;srcY+=sRowSlots){
			int maxXY=srcY+maxX;
			int srcX;
			for(srcX=srcY+minX;srcX<maxXY;srcX++){
#ifdef __BIG_ENDIAN__
                            short rgb = sBits[srcX];
#else
                            short rgb = sBits[srcX^3];
#endif
                            dBits[i++]= ((rgb << 1) & (0xf<<12)) | ((rgb <<2 ) & (0xf<<8)) |
                    ((rgb<<3) & (0xf<<4)) | 0xf;
//				dBits[i++]=sBits[srcX];	// NeXT format is always big-ended, even on LSB platforms
			}
		}
		
		CHECKANDRETURN([[NSBitmapImageRep alloc] initWithBitmapDataPlanes:(unsigned char **)&dBits 
				pixelsWide:right-left
				pixelsHigh:bottom-top
				bitsPerSample:bitsPerSample
				samplesPerPixel:samplesPerPixel
				hasAlpha:NO
				isPlanar:NO
				colorSpaceName:colorSpace
				bytesPerRow:bytesPerRow
				bitsPerPixel:bitsPerPixel]);
	};
	


	-(NSBitmapImageRep*)extractPixels_32_to_32:(void*)srcBits 
			srcPixelWidth:(int)srcPixelWidth
			left:(int)left right:(int)right 
			top:(int)top bottom:(int)bottom
			position:(NSPoint*)position
	{
		debug(int dummy=fprintf(stderr,"%s\n",sel_getName(_cmd));\
			int fummy=fflush(stderr);)
		unsigned long*      sBits=srcBits;
		unsigned long*      dBits;
		int                 bitsPerSample;
		int                 samplesPerPixel;
		int                 bytesPerRow;
		int                 bitsPerPixel;
		NSString*        colorSpace;
		
		int                 neededBytes;
		int                 sRowSlots;
		int                 minY;
		int                 maxY;
		int                 minX;
		int                 maxX;
		int                 srcY;
		int                 i;
		
		sRowSlots=srcPixelWidth;
		[self getPoint:position fromSq:left :bottom];
		
		bitsPerSample=8;
		samplesPerPixel=3;
		bytesPerRow=(right-left)*4;
		bitsPerPixel=32;
		colorSpace=NSDeviceRGBColorSpace;

		neededBytes=bytesPerRow*(bottom-top);
		dBits=(unsigned long*)malloc(neededBytes);
		
		minY=top*sRowSlots;
		maxY=bottom*sRowSlots;
		minX=left;
		maxX=right;
		
		i=0;
		for(srcY=minY;srcY<maxY;srcY+=sRowSlots){
			int maxXY=srcY+maxX;
			int srcX;
			for(srcX=srcY+minX;srcX<maxXY;srcX++){
#ifdef __BIG_ENDIAN__
                                dBits[i++]=(sBits[srcX]<<8) & ~255;
#else
                        int rgb=NSSwapHostLongToBig(sBits[srcX]);
                        dBits[i++]=(rgb)>>8;
#endif
			}
		}
		
		CHECKANDRETURN([[NSBitmapImageRep alloc] initWithBitmapDataPlanes:(unsigned char **)&dBits 
				pixelsWide:right-left
				pixelsHigh:bottom-top
				bitsPerSample:bitsPerSample
				samplesPerPixel:samplesPerPixel
				hasAlpha:NO
				isPlanar:NO
				colorSpaceName:colorSpace
				bytesPerRow:bytesPerRow
				bitsPerPixel:bitsPerPixel]);
	}//extractPixels_32_to_32;


-(void)getPoint:(NSPoint*)point fromSq:(int)x:(int)y
{
    point->x=x;
point->y=[self bounds].size.height-y;
}//getPoint:fromSq::;

-(NSWindowDepth)depthLimit
{
    NSWindowDepth wdepth=[[self window] depthLimit];
    int pixelDepth;

    if(wdepth==0){
        wdepth=[NSWindow defaultDepthLimit];
    }
    pixelDepth = NSBitsPerPixelFromDepth(wdepth);
//        NSLog(@"window = %@ window-depth: %d, pixel-depth=%d",[self window],wdepth,pixelDepth);
        return(pixelDepth);
}//depthLimit;


-(NSBitmapImageRep*)computeBitmapFromBitsIndex:(void*)srcBits
                                                        width:(int)width height:(int)height depth:(int)depth
                                                         left:(int)left right:(int)right
                                                          top:(int)top bottom:(int)bottom
                                                     position:(NSPoint*)position
{
    /*
     It seems that NSImage will replace its NSBitmapImageRep with a
     NXCachedImageRep of the whole bitmap upon receiving a
     composite:fromRect:toPoint: message.
     Therefore:
              1- it is useless to keep our own "cached" image;
              2- we may as well copy to the right format & depth the affected
     rectangle in a temporary bitmap, and draw it directly.
     */
    debug(int dummy=fprintf(stderr,"%s\n",sel_getName(_cmd));\
          int fummy=fflush(stderr);)
    switch(depth){
        case 1:
            return([self extractPixels_1_to_2:srcBits srcPixelWidth:width
                                                        left:left right:right top:top bottom:bottom
                                                    position:position]);
            break;
        case 2:
            return([self extractPixels_2_to_2:srcBits srcPixelWidth:width
                                                        left:left right:right top:top bottom:bottom
                                                    position:position]);
            break;
        case 8:
             switch([self depthLimit]){
                 case 2:
                     return([self extractPixels_8_to_2:srcBits srcPixelWidth:width
                                                                    left:left right:right top:top bottom:bottom
                                                             position:position]);
                     break;
                 case 8:
                     return([self extractPixels_8_to_8:srcBits srcPixelWidth:width
                                                                    left:left right:right top:top bottom:bottom
                                                             position:position]);
                     break;
                 case 12:
                 case 16:
                     return([self extractPixels_8_to_16:srcBits srcPixelWidth:width
                                                                     left:left right:right top:top bottom:bottom
                                                              position:position]);
                     break;
                 case 24:
                 case 32:
                 default:
                     return([self extractPixels_8_to_32:srcBits srcPixelWidth:width
                                          left:left right:right top:top bottom:bottom
                                                     position:position]);
                     }
            break;
        case 16:
            return([self extractPixels_16_to_16:srcBits srcPixelWidth:width
                                                          left:left right:right top:top bottom:bottom
                                                      position:position]);
            break;
        case 32:
            return([self extractPixels_32_to_32:srcBits srcPixelWidth:width
                                                          left:left right:right top:top bottom:bottom
                                                      position:position]);
            break;
        default:
            switch(NSRunAlertPanel(@"Error",
                                   @"NeXTSTEP user interface for Squeak doesn't support image depth of %d.\n",
                                   @"Continue",@"Quit",NULL,depth)){
                case NSAlertDefaultReturn:
                    return(0);
                case NSAlertAlternateReturn:
                    [NSApp squeakTerminate];
                    return(0);
                case NSAlertErrorReturn:
                default:
                    NSLog(@"NeXTSTEP user interface for Squeak doesn't support image depth of %d.\n",depth);
                    [NSApp squeakTerminate];
                    return(0);
                    }
            }
}


@end
