/* SqViewEventSensor.m created by marcel on Sat 23-Dec-2000 */

#import "SqView.h"
#import <Squeak/SqueakInterpreterEventSensor.h>

@implementation SqView(EventSensor)

-(BOOL)acceptsFirstMouse
{
    return YES;
}

-(BOOL)acceptsFirstResponder
{
    return YES;
}

-(NSPoint)mapMouseCoordsToSqueak:(NSPoint)point
{
    point.y=[self bounds].size.height-point.y;
    return point;
}

-(int)ioProcessEvents:(int)microseconds
{
    return 0;
}

-(void)keyDown:(NSEvent*)event
{
    int modifiers=[event modifierFlags];
    [interpreter keyDown:[self characterCodeFromEvent:event]
                 keyCode:0
                   shift:(modifiers & NSShiftKeyMask) != 0
                 control:(modifiers & NSControlKeyMask) != 0
               alternate:(modifiers & NSAlternateKeyMask) != 0
                 command:(modifiers & NSCommandKeyMask) != 0];
}

-(void)passMouseDown:(NSEvent*)event
{
    int modifiers=[event modifierFlags];
//    [[self window] setAcceptsMouseMovedEvents:YES];
    [interpreter mouseAt:[self mapMouseCoordsToSqueak:[event locationInWindow]]
              leftButton:modifiers==0
            middleButton:(modifiers & NSCommandKeyMask) != 0
             rightButton:(modifiers & NSAlternateKeyMask) != 0];
}

-(void)mouseDown:(NSEvent*)event
{
    [self passMouseDown:event];
}

-(void)passMouseUp:(NSEvent*)event
{
    [interpreter mouseAt:[self mapMouseCoordsToSqueak:[event locationInWindow]]
              leftButton:NO
            middleButton:NO
             rightButton:NO];
}

-(void)mouseUp:(NSEvent*)event
{
    [self passMouseUp:event];
}

-(void)mouseMoved:(NSEvent*)event
{
    [self mouseUp:event];
}

-(void)mouseWheel:(NSEvent*)event
{
    
}

-(void)mouseDragged:(NSEvent*)event
{
    [self mouseDown:event];
}

-(void)interrupt:sender
{
    [interpreter interrupt];
}

@end
